﻿using System;

namespace Ascon.AppPlugin
{
    class AppConfiguratorWrapper : IAppConfigurator
    {
        private readonly IPluginAppConfigurator appConfigurator;

        public AppConfiguratorWrapper(IPluginAppConfigurator appConfigurator)
        {
            if (appConfigurator == null) 
                throw new ArgumentNullException("appConfigurator");
            this.appConfigurator = appConfigurator;
        }

        private void ApiCheck(bool res)
        {
            if (!res)
                throw new Exception(appConfigurator.GetLastError());
        }

        public IPluginDataSet GetSortCase(string stProfile, string stType, string stLink, int inIndex)
        {
            IPluginDataSet ds;
            ApiCheck(appConfigurator.GetSortCase(stProfile, stType, stLink, inIndex, out ds)
                );

            return ds;
        }

        public IPluginDataSet GetSortTypes(int inIdCase)
        {
            IPluginDataSet ds;
            ApiCheck(appConfigurator.GetSortTypes(inIdCase, out ds)
                );

            return ds;
        }

        public IPluginDataSet GetSortTree(int inIdCase)
        {
            IPluginDataSet ds;
            ApiCheck(appConfigurator.GetSortTree(inIdCase, out ds)
                );

            return ds;
        }

        public IPluginDataSet GetSortTable(int inIdCase)
        {
            IPluginDataSet ds;
            ApiCheck(appConfigurator.GetSortTable(inIdCase, out ds)
                );

            return ds;
        }
    }
}
