﻿namespace Ascon.AppPlugin
{
	public interface IAppCache
	{
		string GetDBName();
		string GetUserName();
		string GetUserFullName();

		IPluginDataSet GetTypes();
		IPluginDataSet GetStates();
		IPluginDataSet GetDBProperties();
		IPluginDataSet GetLinks();
		IPluginDataSet GetAttributeList();
		IPluginDataSet GetUserList();
		IPluginDataSet GetInfoAboutType(string TypeName, int inMode);
		
		/// <summary>
		/// Аналог стандартной GetLinkAttrForTypes.
		/// </summary>
		/// <returns>Возвращает возможные атрибуты связей для связки типов.</returns>
		IPluginDataSet GetLinkAttrForTypes(string ParentType, string TypeObj, string LinkType);
		IPluginDataSet GetInfoAboutCard(string CardName, int inMode);
		IPluginDataSet GetInfoAboutAttribute(string AttrName, int inMode);
		IPluginDataSet GetInfoAboutCurrentBase(int inMode);
		IPluginDataSet GetAutoOperationList();

		string GetTypeNameById(int Id);
		string GetStateNameById(int Id);
		string GetLinkNameById(int Id);
		string GetDefaultLink(string TypeName, string ParentTypeName);
		string GetDefaultState(string TypeName);

		/// <summary>
		/// Проверяет является ли тип документов.
		/// </summary>
		/// <param name="TypeObj">Наименование типа.</param>
		/// <returns>True - если тип является документов.</returns>
		bool IsDocument(string TypeObj);

		/// <summary>
		/// Проверяет является ли тип документов.
		/// </summary>
		/// <param name="TypeId">Идентификатор типа.</param>
		/// <returns>True - если тип является документов.</returns>
		bool IsDocument(int TypeId);

		IPluginPDMVersions LoadPDMVersionsByIds(string AIds);
	}
}