unit IniProperties;

interface
uses
  Windows,
  SysUtils,
  IniFiles;

type
  //    ini  
  TIniProperties = class
  strict private
    FIniFile: TIniFile;
    function GetFullModulePath: string;
  public
    constructor Create;
    destructor Destroy; override;
    function GetCOMValue: string;
    procedure SetCOMValue(Value: string);
  end;

implementation

{ TIni }

constructor TIniProperties.Create;
var
  FullPath, ModuleName, ModulePath: string;
begin
  FullPath := GetFullModulePath;
  ModulePath := ExtractFilePath(FullPath);
  ModuleName := ExtractFileName(FullPath);
  ModuleName := ChangeFileExt(ModuleName, '.ini');

  FIniFile := TIniFile.Create(ModulePath + ModuleName);
end;

destructor TIniProperties.Destroy;
begin
  FreeAndNil(FIniFile);
  inherited;
end;

function TIniProperties.GetCOMValue: string;
begin
  Result := FIniFile.ReadString('Options', 'COM', '');
end;

function TIniProperties.GetFullModulePath: string;
begin
  Result := '';
  SetLength(Result, MAX_PATH + 1);
  SetLength(Result, GetModuleFileName(HInstance, PChar(Result), Length(Result)));
end;

procedure TIniProperties.SetCOMValue(Value: string);
begin
  FIniFile.WriteString('Options', 'COM', Value);
end;

end.
