unit Form1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,

  PluginIntf,
  PluginIntfWrapper;

type
  TfrmForm1 = class(TForm)
    btnOk: TButton;
    btnCancel: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure btnOkClick(Sender: TObject);
  private
    { Private declarations }
    FAppProvider: TAppProvider;
    FSelectedObjects: IPluginPDMVersions;
    function CreateNewObject: Integer;
    function GetNewGUID: string;
    function GetIdVersionByIdLink(AIdCheckOut, AIdLink: Integer;
      AInverseLink: Boolean): Integer;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent; AAppProvider: TAppProvider); reintroduce;
  end;

implementation

{$R *.dfm}

{ TfrmForm1 }

constructor TfrmForm1.Create(AOwner: TComponent; AAppProvider: TAppProvider);
begin
  inherited Create(AOwner);
  FAppProvider := AAppProvider;
  FSelectedObjects := FAppProvider.GetSelectedObjects;

  Label1.Caption := Format('Product: %s', [FSelectedObjects.Version(0).Product]);
  Label2.Caption := Format('TypeObj: %s', [FSelectedObjects.Version(0).TypeObj]);
  Label3.Caption := Format('State: %s', [FSelectedObjects.Version(0).State]);
end;

procedure TfrmForm1.btnOkClick(Sender: TObject);
var
  Id: Integer;
  IdNewObject: Integer;
begin
  Id := FSelectedObjects.Version(0).IdVersion;
  IdNewObject := CreateNewObject;
  FAppProvider.RefreshVersion(Id);
  FAppProvider.SelectObject(IdNewObject);
  ModalResult := mrOk;
end;

function TfrmForm1.CreateNewObject: Integer;
var
  IdCheckOut: Integer;
  IdNewLink: Integer;
begin
  Result := 0;
  IdCheckOut := FAppProvider.AppMain.CheckOut('', '', '', 0);
  try
    IdNewLink := FAppProvider.AppMain.InsertObject(
                      IdCheckOut,
                      FSelectedObjects.Version(0).TypeObj,
                      FSelectedObjects.Version(0).Product,
                      FSelectedObjects.Version(0).Version,
                      ' ',
                      GetNewGUID,
                      #32,
                      ' ...',
                      '',
                      False);
    if IdNewLink <> 0 then
    begin
      Result := GetIdVersionByIdLink(IdCheckOut, IdNewLink, False);

      FAppProvider.AppMain.UpAttrValueById(IdCheckOut,
                               Result,
                               '  ',
                               ' ',
                               '',
                               False);
    end;
  finally
    if IdCheckOut <> 0 then
      FAppProvider.AppMain.CheckIn(IdCheckOut);
  end;
end;

function TfrmForm1.GetNewGUID: string;
var
  NewGuid: TGUID;
begin
  CreateGUID(NewGuid);
  Result := GUIDToString(NewGuid);
end;

function TfrmForm1.GetIdVersionByIdLink(AIdCheckOut, AIdLink: Integer;
  AInverseLink: Boolean): Integer;
//  Id   Id 
var
  ds: IPluginDataSet;
begin
  ds := FAppProvider.AppMain.GetInfoAboutLink(AIdCheckOut, AIdLink, 2);
  if AInverseLink then  //    
    Result := ds.AsInteger('_ID_PARENT')
  else
    Result := ds.AsInteger('_ID_CHILD');
end;

end.
